#pragma once

#include <Klient.h>
#include <Text.h>
#include "Keys.h"
#include <iostream>
#include <KSGTDatei.h>
#include <Datei.h>

class PSClient
{
private:
    int id;
    Network::Klient *klient;
    char *schlssel;
    unsigned char schlsselLn;
    int port;
    char *ip;
    int ref;

public:
    // Konstruktor
    PSClient( int klientId, unsigned short port, char *ip, char *key, unsigned char keyLen )
    {
        klient = 0;
        id = klientId;
        this->port = port;
        this->ip = new char[ textLength( ip ) + 1 ];
        memcpy( this->ip, ip, textLength( ip ) + 1 );
        schlsselLn = keyLen;
        schlssel = new char[ keyLen ];
        memcpy( schlssel, key, keyLen );
        ref = 1;
    }
    // Destruktor
    ~PSClient()
    {
        delete[] schlssel;
        if( klient )
            trenne( 1 );
        delete[] ip;
        if( klient )
            klient->release();
    }
    // nicht constant
    bool verbinde()
    {
        if( klient )
            return 1;
        klient = new Network::Klient();
        int l = 0;
        char *key;
        Keys::getServerKey( &key, l, Keys::PATCH, Keys::SENDEN );
        klient->setSendeKey( key, l );
        delete[] key;
        Keys::getServerKey( &key, l, Keys::PATCH, Keys::EMPFANGEN );
        klient->setEmpfangKey( key, l );
        delete[] key;
        if( klient->verbinde( port, ip ) )
        {
            klient->sende( "\0", 1 ); // Verschlsselung Aktivieren
            if( klient->sendeEncrypted( "\1", 1 ) )
            {
                klient->sendeEncrypted( (char*)&id, 4 );
                klient->sendeEncrypted( "\2", 1 ); // 64 Bit Client
                char serverReturn = 0;
                klient->getNachrichtEncrypted( &serverReturn, 1 );
                if( serverReturn == 3 )
                {
                    char byte = 0;
                    klient->getNachrichtEncrypted( &byte, 1 );
                    char *f = new char[ byte + 1 ];
                    f[ byte ] = 0;
                    klient->getNachrichtEncrypted( f, byte );
                    std::cerr << "error while identifyin client Patch Server returned: " << f << "\n";
                    delete[]f;
                    klient->sendeEncrypted( "\3", 1 );
                    klient->getNachrichtEncrypted( &serverReturn, 1 );
                    klient->trenne();
                    return 0;
                }
                klient->setSendeKey( (char*)schlssel, schlsselLn );
                klient->setEmpfangKey( (char*)schlssel, schlsselLn );
            }
            else
            {
                std::cerr << "network error while sending to Patch Server\n";
                klient = klient->release();
                return 0;
            }
        }
        else
        {
            std::cerr << "network error while connecting to Patch Server\n";
            klient = klient->release();
            return 0;
        }
        return 1;
    }
    KSGTDatei *getDateiGruppenListe()
    {
        verbinde();
        if( !klient )
            return 0;
        klient->sendeEncrypted( "\xC", 1 );
        char ret = 0;
        klient->getNachrichtEncrypted( &ret, 1 );
        if( ret == 3 )
        { // error
            klient->getNachrichtEncrypted( &ret, 1 );
            char *msg = new char[ ret + 1 ];
            msg[ ret ] = 0;
            if( ret )
                klient->getNachrichtEncrypted( msg, ret );
            std::cerr << "error while getDateiGruppenListe Patch Server returned: " << msg << "\n";
            delete[] msg;
            return 0;
        }
        KSGTDatei *dgtb = new KSGTDatei();
        int id = 0;
        klient->getNachrichtEncrypted( (char*)&id, 4 );
        while( id )
        {
            RCArray< Text > *zeile = new RCArray< Text >();
            Text *idT = new Text();
            idT->append( id );
            zeile->set( idT, 0 );
            int ln = 0;
            klient->getNachrichtEncrypted( (char*)&ln, 4 );
            char *pfad = new char[ ln + 1 ];
            pfad[ ln ] = 0;
            if( ln )
                klient->getNachrichtEncrypted( pfad, ln );
            zeile->set( new Text( pfad ), 1 );
            delete[] pfad;
            int vs = 0;
            klient->getNachrichtEncrypted( (char*)&vs, 4 );
            Text *vsT = new Text();
            vsT->append( vs );
            zeile->set( vsT, 2 );
            dgtb->addZeile( 3, zeile );
            zeile->release();
            klient->getNachrichtEncrypted( (char*)&id, 4 );
        }
        klient->sendeEncrypted( "\1", 1 );
        return dgtb;
    }
    KSGTDatei *getDateiListe( int gruppe )
    {
        verbinde();
        if( !klient )
            return 0;
        klient->sendeEncrypted( "\x9", 1 );
        char ret = 0;
        klient->getNachrichtEncrypted( &ret, 1 );
        if( ret == 1 )
        {
            klient->sendeEncrypted( (char*)&gruppe, 4 );
            klient->getNachrichtEncrypted( &ret, 1 );
        }
        if( ret == 3 )
        { // error
            klient->getNachrichtEncrypted( &ret, 1 );
            char *msg = new char[ ret + 1 ];
            msg[ ret ] = 0;
            if( ret )
                klient->getNachrichtEncrypted( msg, ret );
            std::cerr << "error while getDateiListe Patch Server returned: " << msg << "\n";
            delete[] msg;
            return 0;
        }
        KSGTDatei *dtb = new KSGTDatei();
        int ln = 0;
        klient->getNachrichtEncrypted( (char*)&ln, 4 );
        while( ln )
        {
            RCArray< Text > *zeile = new RCArray< Text >();
            zeile->set( new Text( "1" ), 0 );
            char *pfad = new char[ ln + 1 ];
            pfad[ ln ] = 0;
            klient->getNachrichtEncrypted( pfad, ln );
            zeile->set( new Text( pfad ), 1 );
            delete[] pfad;
            int vs = 0;
            klient->getNachrichtEncrypted( (char*)&vs, 4 );
            Text *vsT = new Text();
            vsT->append( vs );
            zeile->set( vsT, 2 );
            dtb->addZeile( 3, zeile );
            zeile->release();
            klient->getNachrichtEncrypted( (char*)&ln, 4 );
        }
        klient->getNachrichtEncrypted( (char*)&ln, 4 );
        while( ln )
        {
            RCArray< Text > *zeile = new RCArray< Text >();
            zeile->set( new Text( "0" ), 0 );
            char *pfad = new char[ ln + 1 ];
            pfad[ ln ] = 0;
            klient->getNachrichtEncrypted( pfad, ln );
            zeile->set( new Text( pfad ), 1 );
            delete[] pfad;
            dtb->addZeile( 2, zeile );
            zeile->release();
            klient->getNachrichtEncrypted( (char*)&ln, 4 );
        }
        return dtb;
    }
    __int64 getDateiGre( int gruppe, const char *pfad )
    {
        verbinde();
        if( !klient )
            return 0;
        klient->sendeEncrypted( "\xA", 1 );
        char ret = 0;
        klient->getNachrichtEncrypted( &ret, 1 );
        if( ret == 1 )
        {
            klient->sendeEncrypted( (char*)&gruppe, 4 );
            klient->getNachrichtEncrypted( &ret, 1 );
        }
        if( ret == 3 )
        { // error
            klient->getNachrichtEncrypted( &ret, 1 );
            char *msg = new char[ ret + 1 ];
            msg[ ret ] = 0;
            if( ret )
                klient->getNachrichtEncrypted( msg, ret );
            std::cerr << "error while getDateiGre Patch Server returned: " << msg << "\n";
            delete[] msg;
            return 0;
        }
        if( ret == 2 )
        { // verweis auf anderen Server
            klient->getNachrichtEncrypted( (char*)&port, 4 );
            int ln = 0;
            klient->getNachrichtEncrypted( (char*)&ln, 4 );
            delete[] ip;
            ip = new char[ ln + 1 ];
            ip[ ln ] = 0;
            klient->getNachrichtEncrypted( ip, ln );
            if( !trenne( 0 ) )
            {
                delete[] ip;
                return 0;
            }
            if( !verbinde() )
            {
                delete[] ip;
                return 0;
            }
            delete[] ip;
            return getDateiGre( gruppe, pfad );
        }
        int ln = textLength( pfad );
        klient->sendeEncrypted( (char*)&ln, 4 );
        klient->sendeEncrypted( pfad, ln );
        __int64 gre = 0;
        klient->getNachrichtEncrypted( (char*)&gre, 8 );
        return gre;
    }
    bool downloadDatei( int gruppe, __int64 *start, const char *pfad, const char *zielPfad )
    {
        verbinde();
        if( !klient )
            return 0;
        Datei *zielD = new Datei();
        zielD->setDatei( zielPfad );
        if( !zielD->existiert() )
            zielD->erstellen();
        bool ok = 0;
        if( !( *start ) ) // datei neu erstellen
            ok = zielD->open( Datei::Style::schreiben );
        else // datei weiterschreiben
            ok = zielD->open( Datei::Style::schreiben | Datei::Style::lesen );
        if( !ok )
        {
            zielD->release();
            return 0;
        }
        zielD->setSPosition( *start, 0 );
        klient->sendeEncrypted( "\xB", 1 );
        char ret = 0;
        klient->getNachrichtEncrypted( &ret, 1 );
        if( ret == 1 )
        {
            klient->sendeEncrypted( (char*)&gruppe, 4 );
            klient->getNachrichtEncrypted( &ret, 1 );
        }
        if( ret == 3 )
        { // error
            klient->getNachrichtEncrypted( &ret, 1 );
            char *msg = new char[ ret + 1 ];
            msg[ ret ] = 0;
            if( ret )
                klient->getNachrichtEncrypted( msg, ret );
            std::cerr << "error while downloadDatei Patch Server returned: " << msg << "\n";
            delete[] msg;
            zielD->close();
            zielD->release();
            return 0;
        }
        if( ret == 2 )
        { // verweis auf anderen Server
            klient->getNachrichtEncrypted( (char*)&port, 4 );
            int ln = 0;
            klient->getNachrichtEncrypted( (char*)&ln, 4 );
            delete[] ip;
            ip = new char[ ln + 1 ];
            ip[ ln ] = 0;
            klient->getNachrichtEncrypted( ip, ln );
            if( !trenne( 0 ) )
            {
                delete[] ip;
                zielD->close();
                zielD->release();
                return 0;
            }
            if( !verbinde() )
            {
                delete[] ip;
                zielD->close();
                zielD->release();
                return 0;
            }
            delete[] ip;
            zielD->close();
            zielD->release();
            return downloadDatei( gruppe, start, pfad, zielPfad );
        }
        int ln = textLength( pfad );
        klient->sendeEncrypted( (char*)&ln, 4 );
        klient->sendeEncrypted( pfad, ln );
        klient->sendeEncrypted( (char*)start, 8 );
        char *bytes = new char[ 2048 ];
        unsigned short byteLn = 0;
        klient->getNachricht( (char*)&byteLn, 2 );
        if( byteLn )
        {
            int bps = 0;
            double sec = 0;
            while( 1 )
            {
                klient->getNachricht( bytes, byteLn );
                zielD->schreibe( bytes, byteLn );
                ( *start ) += byteLn;
                bps += byteLn;
                if( byteLn == 2048 )
                {
                    klient->getNachricht( (char*)&byteLn, 2 ); // sendelnge empfangen
                    if( !byteLn )
                        break;
                }
                else
                    break;
            }
        }
        delete[] bytes;
        klient->sendeEncrypted( "\1", 1 );
        zielD->close();
        zielD->release();
        return 1;
    }
    bool trenne( bool abmelden )
    {
        verbinde();
        if( !klient )
            return 1;
        if( abmelden )
        {
            klient->sendeEncrypted( "\4", 1 );
            char ret = 0;
            klient->getNachrichtEncrypted( &ret, 1 );
            if( ret == 3 )
            { // error
                klient->getNachrichtEncrypted( &ret, 1 );
                char *msg = new char[ ret + 1 ];
                msg[ ret ] = 0;
                if( ret )
                    klient->getNachrichtEncrypted( msg, ret );
                std::cerr << "error while unregister Client Patch Server returned: " << msg << "\n";
                delete[] msg;
            }
        }
        klient->sendeEncrypted( "\3", 1 );
        char ret = 0;
        klient->getNachrichtEncrypted( &ret, 1 );
        if( ret == 3 )
        { // error
            klient->getNachrichtEncrypted( &ret, 1 );
            char *msg = new char[ ret + 1 ];
            msg[ ret ] = 0;
            if( ret )
                klient->getNachrichtEncrypted( msg, ret );
            std::cerr << "error while trenne Patch Server returned: " << msg << "\n";
            delete[] msg;
        }
        klient->trenne();
        klient = klient->release();
        return 1;
    }
    // Reference Counting
    PSClient *getThis()
    {
        ref++;
        return this;
    }
    PSClient *release()
    {
        ref--;
        if( !ref )
            delete this;
        return 0;
    }
};